<template>
	<div class="form-wrapper">
		<h3>{{ messageFromParent }}</h3>

		<form @submit.prevent="updateMessageFromParent">
			<div class="form-group">
				Default:
				<input type="text" v-model="messageFromParent" />
			</div>
			<div class="form-group">
				Lazy:
				<input type="text" v-model.lazy="messageFromParent" />
			</div>

			<div class="submit-button-wrapper">
				<button class="submit-button" type="submit">Save</button>
			</div>
		</form>

		<button class="alert-button" @click.once="triggerAlert">Alert</button>
	</div>
</template>

<script>
	export default {
		name: "FormEventsExample",
		props: {
			message: String
		},
		data: function () {
			return {
				messageFromParent: this.message
			}
		},
		methods: {
			updateMessageFromParent: function () {
				this.$emit("update:message", this.messageFromParent);
			},
			triggerAlert: function () {
				this.$emit("show:alert");
			}
		}
	}
</script>

<style scoped>
	.form-wrapper {
		background-color: #dcdcdc;
		margin: 20px 400px;
		padding: 20px;
		border-radius: 5px;
	}

	h3 {
		margin: 10px 0 0;
	}

	form {
		width: 400px;
		margin: 0 auto;
		text-align: left;
	}

	input {
		width: 100%;
		margin-top: 5px;
		padding: 8px;
		border: 1px solid #9f9f9f;
	}

	button {
		padding: 5px 20px;
	}

	.form-group {
		margin: 25px 0;
		padding-right: 16px;
	}

	.submit-button-wrapper {
		text-align: right;
	}

	.submit-button {
		margin-top: 10px;
	}

	.alert-button {
		margin-top: 50px;
	}
</style>
